// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Thu Aug 12 11:00:04 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv-ctg/sample_cgfs/rv64i_k.cgf \
//                  --base-isa rv64i \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the aes64ks1i instruction of the RISC-V K extension for the aes64ks1i covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV64IK")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*K.*);def TEST_CASE_1=True;",aes64ks1i)

RVTEST_CASE(1,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*ZKn.*);def TEST_CASE_1=True;",aes64ks1i)

RVTEST_CASE(2,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*ZKne.*);def TEST_CASE_1=True;",aes64ks1i)

RVTEST_SIGBASE( x14,signature_x14_1)

inst_0:
// rs1 != rd, rs1==x7, rd==x8, rs1_val == 0x0706050403020100 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x7; dest:x8; op1val:0x706050403020100;  immval:0xa
TEST_IMM_OP( aes64ks1i, x8, x7, 0x0000000000000000, 0x706050403020100, 0xa, x14, 0, x15)

inst_1:
// rs1 == rd, rs1==x19, rd==x19, rs1_val == 0x71fad878b369e102 and imm_val == 0x0 
// opcode: aes64ks1i ; op1:x19; dest:x19; op1val:0x71fad878b369e102;  immval:0x0
TEST_IMM_OP( aes64ks1i, x19, x19, 0x0000000000000000, 0x71fad878b369e102, 0x0, x14, 8, x15)

inst_2:
// rs1==x12, rd==x10, rs1_val == 0xa4b7f979a8e45869 and imm_val == 0x0 
// opcode: aes64ks1i ; op1:x12; dest:x10; op1val:0xa4b7f979a8e45869;  immval:0x0
TEST_IMM_OP( aes64ks1i, x10, x12, 0x0000000000000000, 0xa4b7f979a8e45869, 0x0, x14, 16, x15)

inst_3:
// rs1==x8, rd==x6, rs1_val == 0x0b3fd605358a9235 and imm_val == 0x1 
// opcode: aes64ks1i ; op1:x8; dest:x6; op1val:0xb3fd605358a9235;  immval:0x1
TEST_IMM_OP( aes64ks1i, x6, x8, 0x0000000000000000, 0xb3fd605358a9235, 0x1, x14, 24, x15)

inst_4:
// rs1==x30, rd==x28, rs1_val == 0xb0873a0f0334fcca and imm_val == 0x7 
// opcode: aes64ks1i ; op1:x30; dest:x28; op1val:0xb0873a0f0334fcca;  immval:0x7
TEST_IMM_OP( aes64ks1i, x28, x30, 0x0000000000000000, 0xb0873a0f0334fcca, 0x7, x14, 32, x15)

inst_5:
// rs1==x16, rd==x13, rs1_val == 0x5b730cad91766f62 and imm_val == 0x7 
// opcode: aes64ks1i ; op1:x16; dest:x13; op1val:0x5b730cad91766f62;  immval:0x7
TEST_IMM_OP( aes64ks1i, x13, x16, 0x0000000000000000, 0x5b730cad91766f62, 0x7, x14, 40, x15)

inst_6:
// rs1==x9, rd==x7, rs1_val == 0xb7c1fc5f1efa1095 and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x9; dest:x7; op1val:0xb7c1fc5f1efa1095;  immval:0x3
TEST_IMM_OP( aes64ks1i, x7, x9, 0x0000000000000000, 0xb7c1fc5f1efa1095, 0x3, x14, 48, x15)

inst_7:
// rs1==x17, rd==x5, rs1_val == 0x25ae27ee4113ee60 and imm_val == 0x5 
// opcode: aes64ks1i ; op1:x17; dest:x5; op1val:0x25ae27ee4113ee60;  immval:0x5
TEST_IMM_OP( aes64ks1i, x5, x17, 0x0000000000000000, 0x25ae27ee4113ee60, 0x5, x14, 56, x15)

inst_8:
// rs1==x4, rd==x21, rs1_val == 0xe3f4fca319f046a5 and imm_val == 0x6 
// opcode: aes64ks1i ; op1:x4; dest:x21; op1val:0xe3f4fca319f046a5;  immval:0x6
TEST_IMM_OP( aes64ks1i, x21, x4, 0x0000000000000000, 0xe3f4fca319f046a5, 0x6, x14, 64, x15)

inst_9:
// rs1==x2, rd==x20, rs1_val == 0xff9a1b805ced7e2e and imm_val == 0x6 
// opcode: aes64ks1i ; op1:x2; dest:x20; op1val:0xff9a1b805ced7e2e;  immval:0x6
TEST_IMM_OP( aes64ks1i, x20, x2, 0x0000000000000000, 0xff9a1b805ced7e2e, 0x6, x14, 72, x15)

inst_10:
// rs1==x0, rd==x1, rs1_val == 0x9722c9a6b0942992 and imm_val == 0x5 
// opcode: aes64ks1i ; op1:x0; dest:x1; op1val:0x0;  immval:0x5
TEST_IMM_OP( aes64ks1i, x1, x0, 0x0000000000000000, 0x0, 0x5, x14, 80, x15)

inst_11:
// rs1==x1, rd==x2, rs1_val == 0x9bedfe390d6ddd9d and imm_val == 0x4 
// opcode: aes64ks1i ; op1:x1; dest:x2; op1val:0x9bedfe390d6ddd9d;  immval:0x4
TEST_IMM_OP( aes64ks1i, x2, x1, 0x0000000000000000, 0x9bedfe390d6ddd9d, 0x4, x14, 88, x15)

inst_12:
// rs1==x13, rd==x27, rs1_val == 0xd75739f82ac177c6 and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x13; dest:x27; op1val:0xd75739f82ac177c6;  immval:0x3
TEST_IMM_OP( aes64ks1i, x27, x13, 0x0000000000000000, 0xd75739f82ac177c6, 0x3, x14, 96, x15)

inst_13:
// rs1==x23, rd==x22, rs1_val == 0x90efb625d9fbcdb5 and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x23; dest:x22; op1val:0x90efb625d9fbcdb5;  immval:0x3
TEST_IMM_OP( aes64ks1i, x22, x23, 0x0000000000000000, 0x90efb625d9fbcdb5, 0x3, x14, 104, x15)

inst_14:
// rs1==x21, rd==x18, rs1_val == 0x60067d39d169a3f8 and imm_val == 0x1 
// opcode: aes64ks1i ; op1:x21; dest:x18; op1val:0x60067d39d169a3f8;  immval:0x1
TEST_IMM_OP( aes64ks1i, x18, x21, 0x0000000000000000, 0x60067d39d169a3f8, 0x1, x14, 112, x15)

inst_15:
// rs1==x18, rd==x24, rs1_val == 0xd5b9fe5cf69bdcf3 and imm_val == 0x6 
// opcode: aes64ks1i ; op1:x18; dest:x24; op1val:0xd5b9fe5cf69bdcf3;  immval:0x6
TEST_IMM_OP( aes64ks1i, x24, x18, 0x0000000000000000, 0xd5b9fe5cf69bdcf3, 0x6, x14, 120, x15)

inst_16:
// rs1==x3, rd==x29, rs1_val == 0x58d548aae4921bf7 and imm_val == 0x6 
// opcode: aes64ks1i ; op1:x3; dest:x29; op1val:0x58d548aae4921bf7;  immval:0x6
TEST_IMM_OP( aes64ks1i, x29, x3, 0x0000000000000000, 0x58d548aae4921bf7, 0x6, x14, 128, x15)

inst_17:
// rs1==x26, rd==x17, rs1_val == 0x2daf9ac7f5faf207 and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x26; dest:x17; op1val:0x2daf9ac7f5faf207;  immval:0x3
TEST_IMM_OP( aes64ks1i, x17, x26, 0x0000000000000000, 0x2daf9ac7f5faf207, 0x3, x14, 136, x15)

inst_18:
// rs1==x6, rd==x11, rs1_val == 0x3acdf61655d98c6e and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x6; dest:x11; op1val:0x3acdf61655d98c6e;  immval:0x3
TEST_IMM_OP( aes64ks1i, x11, x6, 0x0000000000000000, 0x3acdf61655d98c6e, 0x3, x14, 144, x15)

inst_19:
// rs1==x24, rd==x16, rs1_val == 0x436f40f274b8de87 and imm_val == 0x3 
// opcode: aes64ks1i ; op1:x24; dest:x16; op1val:0x436f40f274b8de87;  immval:0x3
TEST_IMM_OP( aes64ks1i, x16, x24, 0x0000000000000000, 0x436f40f274b8de87, 0x3, x14, 152, x2)

inst_20:
// rs1==x10, rd==x31, rs1_val == 0x75a3adb3254a9493 and imm_val == 0x2 
// opcode: aes64ks1i ; op1:x10; dest:x31; op1val:0x75a3adb3254a9493;  immval:0x2
TEST_IMM_OP( aes64ks1i, x31, x10, 0x0000000000000000, 0x75a3adb3254a9493, 0x2, x14, 160, x2)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_21:
// rs1==x25, rd==x14, rs1_val == 0x03020100fffefdfc and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x25; dest:x14; op1val:0x3020100fffefdfc;  immval:0xa
TEST_IMM_OP( aes64ks1i, x14, x25, 0x0000000000000000, 0x3020100fffefdfc, 0xa, x1, 0, x2)

inst_22:
// rs1==x11, rd==x4, rs1_val == 0xfffefdfcfbfaf9f8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x11; dest:x4; op1val:0xfffefdfcfbfaf9f8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x4, x11, 0x0000000000000000, 0xfffefdfcfbfaf9f8, 0xa, x1, 8, x2)

inst_23:
// rs1==x27, rd==x23, rs1_val == 0xfbfaf9f8f7f6f5f4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x27; dest:x23; op1val:0xfbfaf9f8f7f6f5f4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x23, x27, 0x0000000000000000, 0xfbfaf9f8f7f6f5f4, 0xa, x1, 16, x2)

inst_24:
// rs1==x20, rd==x30, rs1_val == 0xf7f6f5f4f3f2f1f0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x20; dest:x30; op1val:0xf7f6f5f4f3f2f1f0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x30, x20, 0x0000000000000000, 0xf7f6f5f4f3f2f1f0, 0xa, x1, 24, x2)

inst_25:
// rs1==x29, rd==x9, rs1_val == 0xf3f2f1f0efeeedec and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x29; dest:x9; op1val:0xf3f2f1f0efeeedec;  immval:0xa
TEST_IMM_OP( aes64ks1i, x9, x29, 0x0000000000000000, 0xf3f2f1f0efeeedec, 0xa, x1, 32, x2)

inst_26:
// rs1==x28, rd==x3, rs1_val == 0xefeeedecebeae9e8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x28; dest:x3; op1val:0xefeeedecebeae9e8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x3, x28, 0x0000000000000000, 0xefeeedecebeae9e8, 0xa, x1, 40, x2)

inst_27:
// rs1==x31, rd==x15, rs1_val == 0xebeae9e8e7e6e5e4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x31; dest:x15; op1val:0xebeae9e8e7e6e5e4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x15, x31, 0x0000000000000000, 0xebeae9e8e7e6e5e4, 0xa, x1, 48, x2)

inst_28:
// rs1==x5, rd==x25, rs1_val == 0xe7e6e5e4e3e2e1e0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x5; dest:x25; op1val:0xe7e6e5e4e3e2e1e0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x25, x5, 0x0000000000000000, 0xe7e6e5e4e3e2e1e0, 0xa, x1, 56, x2)

inst_29:
// rs1==x15, rd==x0, rs1_val == 0xe3e2e1e0dfdedddc and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x15; dest:x0; op1val:0xe3e2e1e0dfdedddc;  immval:0xa
TEST_IMM_OP( aes64ks1i, x0, x15, 0x0000000000000000, 0xe3e2e1e0dfdedddc, 0xa, x1, 64, x2)

inst_30:
// rs1==x14, rd==x26, rs1_val == 0xdfdedddcdbdad9d8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x14; dest:x26; op1val:0xdfdedddcdbdad9d8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x26, x14, 0x0000000000000000, 0xdfdedddcdbdad9d8, 0xa, x1, 72, x2)

inst_31:
// rs1==x22, rd==x12, rs1_val == 0xdbdad9d8d7d6d5d4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x22; dest:x12; op1val:0xdbdad9d8d7d6d5d4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x12, x22, 0x0000000000000000, 0xdbdad9d8d7d6d5d4, 0xa, x1, 80, x2)

inst_32:
// rs1_val == 0xd7d6d5d4d3d2d1d0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xd7d6d5d4d3d2d1d0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xd7d6d5d4d3d2d1d0, 0xa, x1, 88, x2)

inst_33:
// rs1_val == 0xd3d2d1d0cfcecdcc and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xd3d2d1d0cfcecdcc;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xd3d2d1d0cfcecdcc, 0xa, x1, 96, x2)

inst_34:
// rs1_val == 0xcfcecdcccbcac9c8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xcfcecdcccbcac9c8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xcfcecdcccbcac9c8, 0xa, x1, 104, x2)

inst_35:
// rs1_val == 0xcbcac9c8c7c6c5c4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xcbcac9c8c7c6c5c4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xcbcac9c8c7c6c5c4, 0xa, x1, 112, x2)

inst_36:
// rs1_val == 0xc7c6c5c4c3c2c1c0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xc7c6c5c4c3c2c1c0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xc7c6c5c4c3c2c1c0, 0xa, x1, 120, x2)

inst_37:
// rs1_val == 0xc3c2c1c0bfbebdbc and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xc3c2c1c0bfbebdbc;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xc3c2c1c0bfbebdbc, 0xa, x1, 128, x2)

inst_38:
// rs1_val == 0xbfbebdbcbbbab9b8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xbfbebdbcbbbab9b8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xbfbebdbcbbbab9b8, 0xa, x1, 136, x2)

inst_39:
// rs1_val == 0xbbbab9b8b7b6b5b4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xbbbab9b8b7b6b5b4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xbbbab9b8b7b6b5b4, 0xa, x1, 144, x2)

inst_40:
// rs1_val == 0xb7b6b5b4b3b2b1b0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xb7b6b5b4b3b2b1b0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xb7b6b5b4b3b2b1b0, 0xa, x1, 152, x2)

inst_41:
// rs1_val == 0xb3b2b1b0afaeadac and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xb3b2b1b0afaeadac;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xb3b2b1b0afaeadac, 0xa, x1, 160, x2)

inst_42:
// rs1_val == 0xafaeadacabaaa9a8 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xafaeadacabaaa9a8;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xafaeadacabaaa9a8, 0xa, x1, 168, x2)

inst_43:
// rs1_val == 0xabaaa9a8a7a6a5a4 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xabaaa9a8a7a6a5a4;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xabaaa9a8a7a6a5a4, 0xa, x1, 176, x2)

inst_44:
// rs1_val == 0xa7a6a5a4a3a2a1a0 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xa7a6a5a4a3a2a1a0;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xa7a6a5a4a3a2a1a0, 0xa, x1, 184, x2)

inst_45:
// rs1_val == 0xa3a2a1a09f9e9d9c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xa3a2a1a09f9e9d9c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xa3a2a1a09f9e9d9c, 0xa, x1, 192, x2)

inst_46:
// rs1_val == 0x9f9e9d9c9b9a9998 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x9f9e9d9c9b9a9998;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x9f9e9d9c9b9a9998, 0xa, x1, 200, x2)

inst_47:
// rs1_val == 0x9b9a999897969594 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x9b9a999897969594;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x9b9a999897969594, 0xa, x1, 208, x2)

inst_48:
// rs1_val == 0x9796959493929190 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x9796959493929190;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x9796959493929190, 0xa, x1, 216, x2)

inst_49:
// rs1_val == 0x939291908f8e8d8c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x939291908f8e8d8c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x939291908f8e8d8c, 0xa, x1, 224, x2)

inst_50:
// rs1_val == 0x8f8e8d8c8b8a8988 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x8f8e8d8c8b8a8988;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x8f8e8d8c8b8a8988, 0xa, x1, 232, x2)

inst_51:
// rs1_val == 0x8b8a898887868584 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x8b8a898887868584;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x8b8a898887868584, 0xa, x1, 240, x2)

inst_52:
// rs1_val == 0x8786858483828180 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x8786858483828180;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x8786858483828180, 0xa, x1, 248, x2)

inst_53:
// rs1_val == 0x838281807f7e7d7c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x838281807f7e7d7c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x838281807f7e7d7c, 0xa, x1, 256, x2)

inst_54:
// rs1_val == 0x7f7e7d7c7b7a7978 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x7f7e7d7c7b7a7978;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x7f7e7d7c7b7a7978, 0xa, x1, 264, x2)

inst_55:
// rs1_val == 0x7b7a797877767574 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x7b7a797877767574;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x7b7a797877767574, 0xa, x1, 272, x2)

inst_56:
// rs1_val == 0x7776757473727170 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x7776757473727170;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x7776757473727170, 0xa, x1, 280, x2)

inst_57:
// rs1_val == 0x737271706f6e6d6c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x737271706f6e6d6c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x737271706f6e6d6c, 0xa, x1, 288, x2)

inst_58:
// rs1_val == 0x6f6e6d6c6b6a6968 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x6f6e6d6c6b6a6968;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x6f6e6d6c6b6a6968, 0xa, x1, 296, x2)

inst_59:
// rs1_val == 0x6b6a696867666564 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x6b6a696867666564;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x6b6a696867666564, 0xa, x1, 304, x2)

inst_60:
// rs1_val == 0x6766656463626160 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x6766656463626160;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x6766656463626160, 0xa, x1, 312, x2)

inst_61:
// rs1_val == 0x636261605f5e5d5c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x636261605f5e5d5c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x636261605f5e5d5c, 0xa, x1, 320, x2)

inst_62:
// rs1_val == 0x5f5e5d5c5b5a5958 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x5f5e5d5c5b5a5958;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x5f5e5d5c5b5a5958, 0xa, x1, 328, x2)

inst_63:
// rs1_val == 0x5b5a595857565554 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x5b5a595857565554;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x5b5a595857565554, 0xa, x1, 336, x2)

inst_64:
// rs1_val == 0x5756555453525150 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x5756555453525150;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x5756555453525150, 0xa, x1, 344, x2)

inst_65:
// rs1_val == 0x535251504f4e4d4c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x535251504f4e4d4c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x535251504f4e4d4c, 0xa, x1, 352, x2)

inst_66:
// rs1_val == 0x4f4e4d4c4b4a4948 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x4f4e4d4c4b4a4948;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x4f4e4d4c4b4a4948, 0xa, x1, 360, x2)

inst_67:
// rs1_val == 0x4b4a494847464544 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x4b4a494847464544;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x4b4a494847464544, 0xa, x1, 368, x2)

inst_68:
// rs1_val == 0x4746454443424140 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x4746454443424140;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x4746454443424140, 0xa, x1, 376, x2)

inst_69:
// rs1_val == 0x434241403f3e3d3c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x434241403f3e3d3c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x434241403f3e3d3c, 0xa, x1, 384, x2)

inst_70:
// rs1_val == 0x3f3e3d3c3b3a3938 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x3f3e3d3c3b3a3938;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x3f3e3d3c3b3a3938, 0xa, x1, 392, x2)

inst_71:
// rs1_val == 0x3b3a393837363534 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x3b3a393837363534;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x3b3a393837363534, 0xa, x1, 400, x2)

inst_72:
// rs1_val == 0x3736353433323130 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x3736353433323130;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x3736353433323130, 0xa, x1, 408, x2)

inst_73:
// rs1_val == 0x333231302f2e2d2c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x333231302f2e2d2c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x333231302f2e2d2c, 0xa, x1, 416, x2)

inst_74:
// rs1_val == 0x2f2e2d2c2b2a2928 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x2f2e2d2c2b2a2928;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x2f2e2d2c2b2a2928, 0xa, x1, 424, x2)

inst_75:
// rs1_val == 0x2b2a292827262524 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x2b2a292827262524;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x2b2a292827262524, 0xa, x1, 432, x2)

inst_76:
// rs1_val == 0x2726252423222120 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x2726252423222120;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x2726252423222120, 0xa, x1, 440, x2)

inst_77:
// rs1_val == 0x232221201f1e1d1c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x232221201f1e1d1c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x232221201f1e1d1c, 0xa, x1, 448, x2)

inst_78:
// rs1_val == 0x1f1e1d1c1b1a1918 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x1f1e1d1c1b1a1918;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x1f1e1d1c1b1a1918, 0xa, x1, 456, x2)

inst_79:
// rs1_val == 0x1b1a191817161514 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x1b1a191817161514;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x1b1a191817161514, 0xa, x1, 464, x2)

inst_80:
// rs1_val == 0x1716151413121110 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x1716151413121110;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x1716151413121110, 0xa, x1, 472, x2)

inst_81:
// rs1_val == 0x131211100f0e0d0c and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x131211100f0e0d0c;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x131211100f0e0d0c, 0xa, x1, 480, x2)

inst_82:
// rs1_val == 0x0f0e0d0c0b0a0908 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xf0e0d0c0b0a0908;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xf0e0d0c0b0a0908, 0xa, x1, 488, x2)

inst_83:
// rs1_val == 0x0b0a090807060504 and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xb0a090807060504;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xb0a090807060504, 0xa, x1, 496, x2)

inst_84:
// rs1_val == 0x9722c9a6b0942992 and imm_val == 0x5 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0x9722c9a6b0942992;  immval:0x5
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0x9722c9a6b0942992, 0x5, x1, 504, x2)

inst_85:
// rs1_val == 0xe3e2e1e0dfdedddc and imm_val == 0xA 
// opcode: aes64ks1i ; op1:x10; dest:x11; op1val:0xe3e2e1e0dfdedddc;  immval:0xa
TEST_IMM_OP( aes64ks1i, x11, x10, 0x0000000000000000, 0xe3e2e1e0dfdedddc, 0xa, x1, 512, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x14_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x14_1:
    .fill 21*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 65*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
