// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.5
// timestamp : Thu May 20 05:32:05 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv-ctg/sample_cgfs/rv64i_k.cgf \
//                  --base-isa rv64i \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2021. Indian Institute of Technology Madras. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the aes64ks2 instruction of the RISC-V  extension for the aes64ks2 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV64IK")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*K.*);def TEST_CASE_1=True;",aes64ks2)

RVTEST_CASE(1,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*ZKn.*);def TEST_CASE_1=True;",aes64ks2)

RVTEST_CASE(2,"//check ISA:=regex(.*64.*);check ISA:=regex(.*RV64.*I.*ZKne.*);def TEST_CASE_1=True;",aes64ks2)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs1 == rs2 != rd, rs1==x8, rs2==x8, rd==x13, rs1_val == 0x75a3adb3254a9493 and rs2_val == 0xc5521660f3a3c571 
// opcode: aes64ks2 ; op1:x8; op2:x8; dest:x13; op1val:0x75a3adb3254a9493;  op2val:0x75a3adb3254a9493
TEST_RR_OP(aes64ks2, x13, x8, x8, 0x0000000000000000, 0x75a3adb3254a9493, 0x75a3adb3254a9493, x2, 0, x11)

inst_1:
// rs1 == rs2 == rd, rs1==x28, rs2==x28, rd==x28, rs2_val == 9223372036854775807, 
// opcode: aes64ks2 ; op1:x28; op2:x28; dest:x28; op1val:0xd;  op2val:0xd
TEST_RR_OP(aes64ks2, x28, x28, x28, 0x0000000000000000, 0xd, 0xd, x2, 8, x11)

inst_2:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x4, rs2==x0, rd==x24, rs2_val == 13835058055282163711, 
// opcode: aes64ks2 ; op1:x4; op2:x0; dest:x24; op1val:-0x5;  op2val:0x0
TEST_RR_OP(aes64ks2, x24, x4, x0, 0x0000000000000000, -0x5, 0x0, x2, 16, x11)

inst_3:
// rs1 == rd != rs2, rs1==x6, rs2==x22, rd==x6, rs2_val == 16140901064495857663, rs1_val == 281474976710656
// opcode: aes64ks2 ; op1:x6; op2:x22; dest:x6; op1val:0x1000000000000;  op2val:0xdfffffffffffffff
TEST_RR_OP(aes64ks2, x6, x6, x22, 0x0000000000000000, 0x1000000000000, 0xdfffffffffffffff, x2, 24, x11)

inst_4:
// rs2 == rd != rs1, rs1==x10, rs2==x9, rd==x9, rs2_val == 17293822569102704639, rs1_val == 16384
// opcode: aes64ks2 ; op1:x10; op2:x9; dest:x9; op1val:0x4000;  op2val:0xefffffffffffffff
TEST_RR_OP(aes64ks2, x9, x10, x9, 0x0000000000000000, 0x4000, 0xefffffffffffffff, x2, 32, x11)

inst_5:
// rs1==x1, rs2==x7, rd==x20, rs2_val == 17870283321406128127, rs1_val == 131072
// opcode: aes64ks2 ; op1:x1; op2:x7; dest:x20; op1val:0x20000;  op2val:0xf7ffffffffffffff
TEST_RR_OP(aes64ks2, x20, x1, x7, 0x0000000000000000, 0x20000, 0xf7ffffffffffffff, x2, 40, x11)

inst_6:
// rs1==x17, rs2==x23, rd==x7, rs2_val == 18158513697557839871, rs1_val == 70368744177664
// opcode: aes64ks2 ; op1:x17; op2:x23; dest:x7; op1val:0x400000000000;  op2val:0xfbffffffffffffff
TEST_RR_OP(aes64ks2, x7, x17, x23, 0x0000000000000000, 0x400000000000, 0xfbffffffffffffff, x2, 48, x11)

inst_7:
// rs1==x18, rs2==x13, rd==x14, rs2_val == 18302628885633695743, 
// opcode: aes64ks2 ; op1:x18; op2:x13; dest:x14; op1val:-0x4000000000000000;  op2val:0xfdffffffffffffff
TEST_RR_OP(aes64ks2, x14, x18, x13, 0x0000000000000000, -0x4000000000000000, 0xfdffffffffffffff, x2, 56, x11)

inst_8:
// rs1==x12, rs2==x27, rd==x16, rs2_val == 18374686479671623679, rs1_val == 18446744069414584319
// opcode: aes64ks2 ; op1:x12; op2:x27; dest:x16; op1val:0xfffffffeffffffff;  op2val:0xfeffffffffffffff
TEST_RR_OP(aes64ks2, x16, x12, x27, 0x0000000000000000, 0xfffffffeffffffff, 0xfeffffffffffffff, x2, 64, x11)

inst_9:
// rs1==x30, rs2==x17, rd==x31, rs2_val == 18410715276690587647, 
// opcode: aes64ks2 ; op1:x30; op2:x17; dest:x31; op1val:-0x200000001;  op2val:0xff7fffffffffffff
TEST_RR_OP(aes64ks2, x31, x30, x17, 0x0000000000000000, -0x200000001, 0xff7fffffffffffff, x2, 72, x11)

inst_10:
// rs1==x22, rs2==x4, rd==x3, rs2_val == 18428729675200069631, rs1_val == 4611686018427387904
// opcode: aes64ks2 ; op1:x22; op2:x4; dest:x3; op1val:0x4000000000000000;  op2val:0xffbfffffffffffff
TEST_RR_OP(aes64ks2, x3, x22, x4, 0x0000000000000000, 0x4000000000000000, 0xffbfffffffffffff, x2, 80, x11)

inst_11:
// rs1==x9, rs2==x15, rd==x5, rs2_val == 18437736874454810623, 
// opcode: aes64ks2 ; op1:x9; op2:x15; dest:x5; op1val:-0x7;  op2val:0xffdfffffffffffff
TEST_RR_OP(aes64ks2, x5, x9, x15, 0x0000000000000000, -0x7, 0xffdfffffffffffff, x2, 88, x11)

inst_12:
// rs1==x27, rs2==x18, rd==x29, rs2_val == 18442240474082181119, rs1_val == 18446744073709551487
// opcode: aes64ks2 ; op1:x27; op2:x18; dest:x29; op1val:0xffffffffffffff7f;  op2val:0xffefffffffffffff
TEST_RR_OP(aes64ks2, x29, x27, x18, 0x0000000000000000, 0xffffffffffffff7f, 0xffefffffffffffff, x2, 96, x11)

inst_13:
// rs1==x24, rs2==x12, rd==x17, rs2_val == 18444492273895866367, 
// opcode: aes64ks2 ; op1:x24; op2:x12; dest:x17; op1val:-0x20000000001;  op2val:0xfff7ffffffffffff
TEST_RR_OP(aes64ks2, x17, x24, x12, 0x0000000000000000, -0x20000000001, 0xfff7ffffffffffff, x2, 104, x11)

inst_14:
// rs1==x21, rs2==x26, rd==x10, rs2_val == 18445618173802708991, rs1_val == 18014398509481984
// opcode: aes64ks2 ; op1:x21; op2:x26; dest:x10; op1val:0x40000000000000;  op2val:0xfffbffffffffffff
TEST_RR_OP(aes64ks2, x10, x21, x26, 0x0000000000000000, 0x40000000000000, 0xfffbffffffffffff, x2, 112, x11)

inst_15:
// rs1==x0, rs2==x1, rd==x12, rs2_val == 18446181123756130303, 
// opcode: aes64ks2 ; op1:x0; op2:x1; dest:x12; op1val:0x0;  op2val:0xfffdffffffffffff
TEST_RR_OP(aes64ks2, x12, x0, x1, 0x0000000000000000, 0x0, 0xfffdffffffffffff, x2, 120, x8)

inst_16:
// rs1==x15, rs2==x19, rd==x25, rs2_val == 18446462598732840959, rs1_val == 18446744073709551614
// opcode: aes64ks2 ; op1:x15; op2:x19; dest:x25; op1val:0xfffffffffffffffe;  op2val:0xfffeffffffffffff
TEST_RR_OP(aes64ks2, x25, x15, x19, 0x0000000000000000, 0xfffffffffffffffe, 0xfffeffffffffffff, x2, 128, x8)
RVTEST_SIGBASE( x9,signature_x9_0)

inst_17:
// rs1==x13, rs2==x6, rd==x1, rs2_val == 18446603336221196287, 
// opcode: aes64ks2 ; op1:x13; op2:x6; dest:x1; op1val:-0x40001;  op2val:0xffff7fffffffffff
TEST_RR_OP(aes64ks2, x1, x13, x6, 0x0000000000000000, -0x40001, 0xffff7fffffffffff, x9, 0, x8)

inst_18:
// rs1==x7, rs2==x2, rd==x30, rs2_val == 18446673704965373951, 
// opcode: aes64ks2 ; op1:x7; op2:x2; dest:x30; op1val:0x400000000000;  op2val:0xffffbfffffffffff
TEST_RR_OP(aes64ks2, x30, x7, x2, 0x0000000000000000, 0x400000000000, 0xffffbfffffffffff, x9, 8, x8)

inst_19:
// rs1==x29, rs2==x5, rd==x2, rs2_val == 18446708889337462783, rs1_val == 16
// opcode: aes64ks2 ; op1:x29; op2:x5; dest:x2; op1val:0x10;  op2val:0xffffdfffffffffff
TEST_RR_OP(aes64ks2, x2, x29, x5, 0x0000000000000000, 0x10, 0xffffdfffffffffff, x9, 16, x8)

inst_20:
// rs1==x25, rs2==x20, rd==x19, rs2_val == 18446726481523507199, 
// opcode: aes64ks2 ; op1:x25; op2:x20; dest:x19; op1val:-0x40001;  op2val:0xffffefffffffffff
TEST_RR_OP(aes64ks2, x19, x25, x20, 0x0000000000000000, -0x40001, 0xffffefffffffffff, x9, 24, x8)

inst_21:
// rs1==x26, rs2==x14, rd==x4, rs2_val == 18446735277616529407, 
// opcode: aes64ks2 ; op1:x26; op2:x14; dest:x4; op1val:0x400000000000;  op2val:0xfffff7ffffffffff
TEST_RR_OP(aes64ks2, x4, x26, x14, 0x0000000000000000, 0x400000000000, 0xfffff7ffffffffff, x9, 32, x8)

inst_22:
// rs1==x19, rs2==x24, rd==x23, rs2_val == 18446739675663040511, 
// opcode: aes64ks2 ; op1:x19; op2:x24; dest:x23; op1val:-0x1000000000001;  op2val:0xfffffbffffffffff
TEST_RR_OP(aes64ks2, x23, x19, x24, 0x0000000000000000, -0x1000000000001, 0xfffffbffffffffff, x9, 40, x8)

inst_23:
// rs1==x3, rs2==x16, rd==x15, rs2_val == 18446741874686296063, rs1_val == 18158513697557839871
// opcode: aes64ks2 ; op1:x3; op2:x16; dest:x15; op1val:0xfbffffffffffffff;  op2val:0xfffffdffffffffff
TEST_RR_OP(aes64ks2, x15, x3, x16, 0x0000000000000000, 0xfbffffffffffffff, 0xfffffdffffffffff, x9, 48, x8)

inst_24:
// rs1==x31, rs2==x11, rd==x21, rs2_val == 18446742974197923839, rs1_val == 18446744073707454463
// opcode: aes64ks2 ; op1:x31; op2:x11; dest:x21; op1val:0xffffffffffdfffff;  op2val:0xfffffeffffffffff
TEST_RR_OP(aes64ks2, x21, x31, x11, 0x0000000000000000, 0xffffffffffdfffff, 0xfffffeffffffffff, x9, 56, x8)

inst_25:
// rs1==x14, rs2==x21, rd==x27, rs2_val == 18446743523953737727, 
// opcode: aes64ks2 ; op1:x14; op2:x21; dest:x27; op1val:0x4000000000000000;  op2val:0xffffff7fffffffff
TEST_RR_OP(aes64ks2, x27, x14, x21, 0x0000000000000000, 0x4000000000000000, 0xffffff7fffffffff, x9, 64, x8)

inst_26:
// rs1==x5, rs2==x30, rd==x18, rs2_val == 18446743798831644671, rs1_val == 8
// opcode: aes64ks2 ; op1:x5; op2:x30; dest:x18; op1val:0x8;  op2val:0xffffffbfffffffff
TEST_RR_OP(aes64ks2, x18, x5, x30, 0x0000000000000000, 0x8, 0xffffffbfffffffff, x9, 72, x8)

inst_27:
// rs1==x2, rs2==x29, rd==x11, rs2_val == 18446743936270598143, 
// opcode: aes64ks2 ; op1:x2; op2:x29; dest:x11; op1val:-0x800000000000001;  op2val:0xffffffdfffffffff
TEST_RR_OP(aes64ks2, x11, x2, x29, 0x0000000000000000, -0x800000000000001, 0xffffffdfffffffff, x9, 80, x8)

inst_28:
// rs1==x20, rs2==x10, rd==x0, rs2_val == 18446744004990074879, 
// opcode: aes64ks2 ; op1:x20; op2:x10; dest:x0; op1val:-0xa;  op2val:0xffffffefffffffff
TEST_RR_OP(aes64ks2, x0, x20, x10, 0x0000000000000000, -0xa, 0xffffffefffffffff, x9, 88, x8)

inst_29:
// rs1==x16, rs2==x25, rd==x26, rs2_val == 18446744039349813247, rs1_val == 2251799813685248
// opcode: aes64ks2 ; op1:x16; op2:x25; dest:x26; op1val:0x8000000000000;  op2val:0xfffffff7ffffffff
TEST_RR_OP(aes64ks2, x26, x16, x25, 0x0000000000000000, 0x8000000000000, 0xfffffff7ffffffff, x9, 96, x8)

inst_30:
// rs1==x23, rs2==x3, rd==x22, rs2_val == 18446744056529682431, rs1_val == 35184372088832
// opcode: aes64ks2 ; op1:x23; op2:x3; dest:x22; op1val:0x200000000000;  op2val:0xfffffffbffffffff
TEST_RR_OP(aes64ks2, x22, x23, x3, 0x0000000000000000, 0x200000000000, 0xfffffffbffffffff, x9, 104, x8)

inst_31:
// rs1==x11, rs2==x31, rd==x8, rs2_val == 18446744065119617023, rs1_val == 72057594037927936
// opcode: aes64ks2 ; op1:x11; op2:x31; dest:x8; op1val:0x100000000000000;  op2val:0xfffffffdffffffff
TEST_RR_OP(aes64ks2, x8, x11, x31, 0x0000000000000000, 0x100000000000000, 0xfffffffdffffffff, x9, 112, x2)

inst_32:
// rs2_val == 18446744069414584319, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffffe;  op2val:0xfffffffeffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffffe, 0xfffffffeffffffff, x9, 120, x2)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_33:
// rs2_val == 18446744071562067967, rs1_val == 34359738368
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800000000;  op2val:0xffffffff7fffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800000000, 0xffffffff7fffffff, x1, 0, x2)

inst_34:
// rs2_val == 18446744072635809791, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0xffffffffbfffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x40001, 0xffffffffbfffffff, x1, 8, x2)

inst_35:
// rs2_val == 18446744073172680703, rs1_val == 18446744073709543423
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffdfff;  op2val:0xffffffffdfffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffdfff, 0xffffffffdfffffff, x1, 16, x2)

inst_36:
// rs2_val == 18446744073441116159, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x8000000001;  op2val:0xffffffffefffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x8000000001, 0xffffffffefffffff, x1, 24, x2)

inst_37:
// rs2_val == 18446744073575333887, rs1_val == 18446744056529682431
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffbffffffff;  op2val:0xfffffffff7ffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffbffffffff, 0xfffffffff7ffffff, x1, 32, x2)

inst_38:
// rs2_val == 18446744073642442751, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000000001;  op2val:0xfffffffffbffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x80000000000001, 0xfffffffffbffffff, x1, 40, x2)

inst_39:
// rs2_val == 18446744073675997183, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xfffffffffdffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x6, 0xfffffffffdffffff, x1, 48, x2)

inst_40:
// rs2_val == 18446744073692774399, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x200000000000001;  op2val:0xfffffffffeffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x200000000000001, 0xfffffffffeffffff, x1, 56, x2)

inst_41:
// rs2_val == 18446744073701163007, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800000000;  op2val:0xffffffffff7fffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800000000, 0xffffffffff7fffff, x1, 64, x2)

inst_42:
// rs2_val == 18446744073705357311, rs1_val == 33554432
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0xffffffffffbfffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2000000, 0xffffffffffbfffff, x1, 72, x2)

inst_43:
// rs2_val == 18446744073707454463, rs1_val == 18446741874686296063
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffdffffffffff;  op2val:0xffffffffffdfffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffdffffffffff, 0xffffffffffdfffff, x1, 80, x2)

inst_44:
// rs2_val == 18446744073708503039, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000000000;  op2val:0xffffffffffefffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000000000, 0xffffffffffefffff, x1, 88, x2)

inst_45:
// rs2_val == 18446744073709027327, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x1;  op2val:0xfffffffffff7ffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x1, 0xfffffffffff7ffff, x1, 96, x2)

inst_46:
// rs2_val == 18446744073709289471, rs1_val == 18446603336221196287
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffff7fffffffffff;  op2val:0xfffffffffffbffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffff7fffffffffff, 0xfffffffffffbffff, x1, 104, x2)

inst_47:
// rs2_val == 18446744073709420543, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x80000001;  op2val:0xfffffffffffdffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x80000001, 0xfffffffffffdffff, x1, 112, x2)

inst_48:
// rs2_val == 18446744073709486079, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xfffffffffffeffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x5, 0xfffffffffffeffff, x1, 120, x2)

inst_49:
// rs2_val == 18446744073709518847, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xc;  op2val:0xffffffffffff7fff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xc, 0xffffffffffff7fff, x1, 128, x2)

inst_50:
// rs2_val == 18446744073709535231, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0xffffffffffffbfff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x10, 0xffffffffffffbfff, x1, 136, x2)

inst_51:
// rs2_val == 18446744073709543423, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0xffffffffffffdfff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x201, 0xffffffffffffdfff, x1, 144, x2)

inst_52:
// rs2_val == 18446744073709547519, rs1_val == 128
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:0xffffffffffffefff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x80, 0xffffffffffffefff, x1, 152, x2)

inst_53:
// rs2_val == 18446744073709549567, rs1_val == 4398046511104
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x40000000000;  op2val:0xfffffffffffff7ff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x40000000000, 0xfffffffffffff7ff, x1, 160, x2)

inst_54:
// rs2_val == 18446744073709550591, rs1_val == 144115188075855872
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x200000000000000;  op2val:0xfffffffffffffbff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x200000000000000, 0xfffffffffffffbff, x1, 168, x2)

inst_55:
// rs2_val == 18446744073709551103, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:0xfffffffffffffdff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x200001, 0xfffffffffffffdff, x1, 176, x2)

inst_56:
// rs2_val == 18446744073709551359, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0xfffffffffffffeff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000, 0xfffffffffffffeff, x1, 184, x2)

inst_57:
// rs2_val == 18446744073709551487, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0xffffffffffffff7f
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x201, 0xffffffffffffff7f, x1, 192, x2)

inst_58:
// rs2_val == 18446744073709551551, rs1_val == 18437736874454810623
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffdfffffffffffff;  op2val:0xffffffffffffffbf
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffdfffffffffffff, 0xffffffffffffffbf, x1, 200, x2)

inst_59:
// rs2_val == 18446744073709551583, rs1_val == 1073741824
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0xffffffffffffffdf
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x40000000, 0xffffffffffffffdf, x1, 208, x2)

inst_60:
// rs2_val == 18446744073709551599, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x2000000000000001;  op2val:0xffffffffffffffef
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x2000000000000001, 0xffffffffffffffef, x1, 216, x2)

inst_61:
// rs2_val == 18446744073709551607, rs1_val == 1
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xfffffffffffffff7
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1, 0xfffffffffffffff7, x1, 224, x2)

inst_62:
// rs2_val == 18446744073709551611, rs1_val == 1152921504606846976
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1000000000000000;  op2val:0xfffffffffffffffb
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1000000000000000, 0xfffffffffffffffb, x1, 232, x2)

inst_63:
// rs2_val == 18446744073709551613, rs1_val == 18446744065119617023
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffdffffffff;  op2val:0xfffffffffffffffd
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffdffffffff, 0xfffffffffffffffd, x1, 240, x2)

inst_64:
// rs2_val == 18446744073709551614, rs1_val == 1125899906842624
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000000000000;  op2val:0xfffffffffffffffe
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000000000000, 0xfffffffffffffffe, x1, 248, x2)

inst_65:
// rs1_val == 9223372036854775807, rs2_val == 17179869184
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x7fffffffffffffff;  op2val:0x400000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x7fffffffffffffff, 0x400000000, x1, 256, x2)

inst_66:
// rs1_val == 13835058055282163711, rs2_val == 2305843009213693952
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xbfffffffffffffff;  op2val:0x2000000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xbfffffffffffffff, 0x2000000000000000, x1, 264, x2)

inst_67:
// rs1_val == 16140901064495857663, rs2_val == 137438953472
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xdfffffffffffffff;  op2val:0x2000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xdfffffffffffffff, 0x2000000000, x1, 272, x2)

inst_68:
// rs1_val == 17293822569102704639, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xefffffffffffffff;  op2val:-0x2
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xefffffffffffffff, -0x2, x1, 280, x2)

inst_69:
// rs1_val == 17870283321406128127, rs2_val == 32
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xf7ffffffffffffff;  op2val:0x20
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xf7ffffffffffffff, 0x20, x1, 288, x2)

inst_70:
// rs1_val == 18302628885633695743, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfdffffffffffffff;  op2val:-0x40000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfdffffffffffffff, -0x40000000001, x1, 296, x2)

inst_71:
// rs1_val == 18374686479671623679, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfeffffffffffffff;  op2val:0xfffffffeffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfeffffffffffffff, 0xfffffffeffffffff, x1, 304, x2)

inst_72:
// rs1_val == 18410715276690587647, rs2_val == 70368744177664
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xff7fffffffffffff;  op2val:0x400000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xff7fffffffffffff, 0x400000000000, x1, 312, x2)

inst_73:
// rs1_val == 18428729675200069631, rs2_val == 8192
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffbfffffffffffff;  op2val:0x2000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffbfffffffffffff, 0x2000, x1, 320, x2)

inst_74:
// rs1_val == 18442240474082181119, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffefffffffffffff;  op2val:0x9
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffefffffffffffff, 0x9, x1, 328, x2)

inst_75:
// rs1_val == 18444492273895866367, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfff7ffffffffffff;  op2val:-0x1000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfff7ffffffffffff, -0x1000001, x1, 336, x2)

inst_76:
// rs1_val == 18445618173802708991, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffbffffffffffff;  op2val:-0x100000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffbffffffffffff, -0x100000001, x1, 344, x2)

inst_77:
// rs1_val == 18446181123756130303, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffdffffffffffff;  op2val:0xffffffffffff7fff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffdffffffffffff, 0xffffffffffff7fff, x1, 352, x2)

inst_78:
// rs1_val == 18446462598732840959, rs2_val == 4503599627370496
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffeffffffffffff;  op2val:0x10000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffeffffffffffff, 0x10000000000000, x1, 360, x2)

inst_79:
// rs1_val == 18446673704965373951, rs2_val == 2
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffbfffffffffff;  op2val:0x2
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffbfffffffffff, 0x2, x1, 368, x2)

inst_80:
// rs1_val == 18446708889337462783, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffdfffffffffff;  op2val:0xfffffdffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffdfffffffffff, 0xfffffdffffffffff, x1, 376, x2)

inst_81:
// rs1_val == 18446726481523507199, rs2_val == 144115188075855872
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffefffffffffff;  op2val:0x200000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffefffffffffff, 0x200000000000000, x1, 384, x2)

inst_82:
// rs1_val == 18446735277616529407, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffff7ffffffffff;  op2val:0xfffffffff7ffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffff7ffffffffff, 0xfffffffff7ffffff, x1, 392, x2)

inst_83:
// rs1_val == 18446739675663040511, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffbffffffffff;  op2val:-0x100001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffbffffffffff, -0x100001, x1, 400, x2)

inst_84:
// rs1_val == 18446742974197923839, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffeffffffffff;  op2val:0xefffffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffeffffffffff, 0xefffffffffffffff, x1, 408, x2)

inst_85:
// rs1_val == 18446743523953737727, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffff7fffffffff;  op2val:-0x4000000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffff7fffffffff, -0x4000000000000000, x1, 416, x2)

inst_86:
// rs1_val == 18446743798831644671, rs2_val == 64
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffbfffffffff;  op2val:0x40
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffbfffffffff, 0x40, x1, 424, x2)

inst_87:
// rs1_val == 18446743936270598143, rs2_val == 18014398509481984
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffdfffffffff;  op2val:0x40000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffdfffffffff, 0x40000000000000, x1, 432, x2)

inst_88:
// rs1_val == 18446744004990074879, rs2_val == 131072
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffefffffffff;  op2val:0x20000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffefffffffff, 0x20000, x1, 440, x2)

inst_89:
// rs1_val == 18446744039349813247, rs2_val == 2251799813685248
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffff7ffffffff;  op2val:0x8000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffff7ffffffff, 0x8000000000000, x1, 448, x2)

inst_90:
// rs1_val == 18446744071562067967, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffff7fffffff;  op2val:0x6
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffff7fffffff, 0x6, x1, 456, x2)

inst_91:
// rs1_val == 18446744072635809791, rs2_val == 1099511627776
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffbfffffff;  op2val:0x10000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffbfffffff, 0x10000000000, x1, 464, x2)

inst_92:
// rs1_val == 18446744073172680703, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffdfffffff;  op2val:-0x1000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffdfffffff, -0x1000001, x1, 472, x2)

inst_93:
// rs1_val == 18446744073441116159, rs2_val == 268435456
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffefffffff;  op2val:0x10000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffefffffff, 0x10000000, x1, 480, x2)

inst_94:
// rs1_val == 18446744073575333887, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffff7ffffff;  op2val:0x3
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffff7ffffff, 0x3, x1, 488, x2)

inst_95:
// rs1_val == 18446744073642442751, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffbffffff;  op2val:-0x40000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffbffffff, -0x40000000001, x1, 496, x2)

inst_96:
// rs1_val == 18446744073675997183, rs2_val == 1
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffdffffff;  op2val:0x1
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffdffffff, 0x1, x1, 504, x2)

inst_97:
// rs1_val == 18446744073692774399, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffeffffff;  op2val:-0x100000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffeffffff, -0x100000001, x1, 512, x2)

inst_98:
// rs1_val == 18446744073701163007, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffff7fffff;  op2val:0xfffffffffffffffd
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffff7fffff, 0xfffffffffffffffd, x1, 520, x2)

inst_99:
// rs1_val == 18446744073705357311, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffbfffff;  op2val:0x7fffffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffbfffff, 0x7fffffffffffffff, x1, 528, x2)

inst_100:
// rs1_val == 18446744073708503039, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffefffff;  op2val:0x12
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffefffff, 0x12, x1, 536, x2)

inst_101:
// rs1_val == 18446744073709027327, rs2_val == 140737488355328
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffff7ffff;  op2val:0x800000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffff7ffff, 0x800000000000, x1, 544, x2)

inst_102:
// rs1_val == 0x6af29145404fd8ed and rs2_val == 0x990e75eafff569c2 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x6af29145404fd8ed;  op2val:0x990e75eafff569c2
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x6af29145404fd8ed, 0x990e75eafff569c2, x1, 552, x2)

inst_103:
// rs1_val == 0x6d23c0488a6019c1 and rs2_val == 0x860bdaad7447a088 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x6d23c0488a6019c1;  op2val:0x860bdaad7447a088
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x6d23c0488a6019c1, 0x860bdaad7447a088, x1, 560, x2)

inst_104:
// rs1_val == 0x1f7d946f17168ab3 and rs2_val == 0x66eae3d9bbb4f560 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1f7d946f17168ab3;  op2val:0x66eae3d9bbb4f560
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1f7d946f17168ab3, 0x66eae3d9bbb4f560, x1, 568, x2)

inst_105:
// rs1_val == 0xef1d54db32b81f27 and rs2_val == 0x1826a804284fe16c 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xef1d54db32b81f27;  op2val:0x1826a804284fe16c
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xef1d54db32b81f27, 0x1826a804284fe16c, x1, 576, x2)

inst_106:
// rs1_val == 0xb694de26ad9e5431 and rs2_val == 0x293f9f6071fad878 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xb694de26ad9e5431;  op2val:0x293f9f6071fad878
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xb694de26ad9e5431, 0x293f9f6071fad878, x1, 584, x2)

inst_107:
// rs1_val == 0x987daa20b858e304 and rs2_val == 0x1aa1beebefb902cb 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x987daa20b858e304;  op2val:0x1aa1beebefb902cb
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x987daa20b858e304, 0x1aa1beebefb902cb, x1, 592, x2)

inst_108:
// rs1_val == 0x79bb7c341d3110bc and rs2_val == 0x8678f5e3d272e229 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x79bb7c341d3110bc;  op2val:0x8678f5e3d272e229
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x79bb7c341d3110bc, 0x8678f5e3d272e229, x1, 600, x2)

inst_109:
// rs1_val == 0xe2eaf4a09869be8c and rs2_val == 0x5b730cad91766f62 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xe2eaf4a09869be8c;  op2val:0x5b730cad91766f62
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xe2eaf4a09869be8c, 0x5b730cad91766f62, x1, 608, x2)

inst_110:
// rs1_val == 0xc0fe15dd0df9564b and rs2_val == 0xb22bbf7eb4c858fb 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xc0fe15dd0df9564b;  op2val:0xb22bbf7eb4c858fb
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xc0fe15dd0df9564b, 0xb22bbf7eb4c858fb, x1, 616, x2)

inst_111:
// rs1_val == 0x4113ee60952acffe and rs2_val == 0x53a66ed1dc80d916 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4113ee60952acffe;  op2val:0x53a66ed1dc80d916
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4113ee60952acffe, 0x53a66ed1dc80d916, x1, 624, x2)

inst_112:
// rs1_val == 0x40a5ff526f38a9c7 and rs2_val == 0xb6f9706fb4f741aa 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x40a5ff526f38a9c7;  op2val:0xb6f9706fb4f741aa
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x40a5ff526f38a9c7, 0xb6f9706fb4f741aa, x1, 632, x2)

inst_113:
// rs1_val == 0x9bedfe390d6ddd9d and rs2_val == 0xd05668ae0fdb82bc 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x9bedfe390d6ddd9d;  op2val:0xd05668ae0fdb82bc
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x9bedfe390d6ddd9d, 0xd05668ae0fdb82bc, x1, 640, x2)

inst_114:
// rs1_val == 0xd75739f82ac177c6 and rs2_val == 0xaa6bb2bde9ed477d 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xd75739f82ac177c6;  op2val:0xaa6bb2bde9ed477d
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xd75739f82ac177c6, 0xaa6bb2bde9ed477d, x1, 648, x2)

inst_115:
// rs1_val == 0x9a4e9ef10171f4df and rs2_val == 0x299c3bcf90efb625 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x9a4e9ef10171f4df;  op2val:0x299c3bcf90efb625
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x9a4e9ef10171f4df, 0x299c3bcf90efb625, x1, 656, x2)

inst_116:
// rs1_val == 0xd169a3f8cad5e297 and rs2_val == 0x1fc493caa371db42 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xd169a3f8cad5e297;  op2val:0x1fc493caa371db42
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xd169a3f8cad5e297, 0x1fc493caa371db42, x1, 664, x2)

inst_117:
// rs1_val == 0xd5b9fe5cf69bdcf3 and rs2_val == 0xf4c30307672f666d 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xd5b9fe5cf69bdcf3;  op2val:0xf4c30307672f666d
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xd5b9fe5cf69bdcf3, 0xf4c30307672f666d, x1, 672, x2)

inst_118:
// rs1_val == 0xe4921bf73047c198 and rs2_val == 0xa0569d765ebc64cb 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xe4921bf73047c198;  op2val:0xa0569d765ebc64cb
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xe4921bf73047c198, 0xa0569d765ebc64cb, x1, 680, x2)

inst_119:
// rs1_val == 0xfcc1b543c49cd65b and rs2_val == 0x2daf9ac7f5faf207 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfcc1b543c49cd65b;  op2val:0x2daf9ac7f5faf207
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfcc1b543c49cd65b, 0x2daf9ac7f5faf207, x1, 688, x2)

inst_120:
// rs1_val == 0x436f40f274b8de87 and rs2_val == 0x3459294ef273b44c 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x436f40f274b8de87;  op2val:0x3459294ef273b44c
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x436f40f274b8de87, 0x3459294ef273b44c, x1, 696, x2)

inst_121:
// rs1_val == 18446744073709289471, rs2_val == 72057594037927936
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffbffff;  op2val:0x100000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffbffff, 0x100000000000000, x1, 704, x2)

inst_122:
// rs1_val == 18446744073709420543, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffdffff;  op2val:-0x40000000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffdffff, -0x40000000000001, x1, 712, x2)

inst_123:
// rs1_val == 18446744073709486079, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffeffff;  op2val:-0x10000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffeffff, -0x10000000001, x1, 720, x2)

inst_124:
// rs1_val == 18446744073709518847, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffff7fff;  op2val:-0x9
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffff7fff, -0x9, x1, 728, x2)

inst_125:
// rs1_val == 18446744073709535231, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffbfff;  op2val:0xfffffffffdffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffbfff, 0xfffffffffdffffff, x1, 736, x2)

inst_126:
// rs1_val == 18446744073709547519, rs2_val == 1152921504606846976
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffefff;  op2val:0x1000000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffefff, 0x1000000000000000, x1, 744, x2)

inst_127:
// rs1_val == 18446744073709549567, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffff7ff;  op2val:0x5555555555555555
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffff7ff, 0x5555555555555555, x1, 752, x2)

inst_128:
// rs1_val == 18446744073709550591, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffbff;  op2val:0xfffffffdffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffbff, 0xfffffffdffffffff, x1, 760, x2)

inst_129:
// rs1_val == 18446744073709551103, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffdff;  op2val:0x100000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffdff, 0x100000000000000, x1, 768, x2)

inst_130:
// rs1_val == 18446744073709551359, rs2_val == 4194304
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffeff;  op2val:0x400000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffeff, 0x400000, x1, 776, x2)

inst_131:
// rs1_val == 18446744073709551551, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffffbf;  op2val:-0x2000000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffffbf, -0x2000000000001, x1, 784, x2)

inst_132:
// rs1_val == 18446744073709551583, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffffdf;  op2val:0x2
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffffdf, 0x2, x1, 792, x2)

inst_133:
// rs1_val == 18446744073709551599, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffffffffef;  op2val:0x2000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffffffffef, 0x2000000000, x1, 800, x2)

inst_134:
// rs1_val == 18446744073709551607, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffff7;  op2val:0x40000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffff7, 0x40000000000000, x1, 808, x2)

inst_135:
// rs1_val == 18446744073709551611, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffffb;  op2val:0x400000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffffb, 0x400000000000, x1, 816, x2)

inst_136:
// rs1_val == 18446744073709551613, rs2_val == 2097152
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffffd;  op2val:0x200000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffffd, 0x200000, x1, 824, x2)

inst_137:
// rs2_val == 9223372036854775808, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffdfffffffff;  op2val:0x8000000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffdfffffffff, 0x8000000000000000, x1, 832, x2)

inst_138:
// rs2_val == 4611686018427387904, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x5555555555555555;  op2val:0x4000000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x5555555555555555, 0x4000000000000000, x1, 840, x2)

inst_139:
// rs2_val == 576460752303423488, rs1_val == 576460752303423488
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800000000000000;  op2val:0x800000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800000000000000, 0x800000000000000, x1, 848, x2)

inst_140:
// rs2_val == 288230376151711744, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xd;  op2val:0x400000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xd, 0x400000000000000, x1, 856, x2)

inst_141:
// rs2_val == 36028797018963968, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffbfffffffffffff;  op2val:0x80000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffbfffffffffffff, 0x80000000000000, x1, 864, x2)

inst_142:
// rs2_val == 9007199254740992, rs1_val == 9007199254740992
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x20000000000000;  op2val:0x20000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x20000000000000, 0x20000000000000, x1, 872, x2)

inst_143:
// rs2_val == 1125899906842624, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000000000;  op2val:0x4000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000000000, 0x4000000000000, x1, 880, x2)

inst_144:
// rs2_val == 562949953421312, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffdffffff;  op2val:0x2000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffdffffff, 0x2000000000000, x1, 888, x2)

inst_145:
// rs2_val == 281474976710656, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0x1000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x81, 0x1000000000000, x1, 896, x2)

inst_146:
// rs2_val == 35184372088832, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000001;  op2val:0x200000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x80000000001, 0x200000000000, x1, 904, x2)

inst_147:
// rs2_val == 17592186044416, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x20000000000000;  op2val:0x100000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x20000000000000, 0x100000000000, x1, 912, x2)

inst_148:
// rs2_val == 8796093022208, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffff7fffffff;  op2val:0x80000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffff7fffffff, 0x80000000000, x1, 920, x2)

inst_149:
// rs2_val == 4398046511104, rs1_val == 2305843009213693952
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2000000000000000;  op2val:0x40000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2000000000000000, 0x40000000000, x1, 928, x2)

inst_150:
// rs2_val == 2199023255552, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffffffbfffffff;  op2val:0x20000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffffffbfffffff, 0x20000000000, x1, 936, x2)

inst_151:
// rs2_val == 549755813888, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:0x8000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8, 0x8000000000, x1, 944, x2)

inst_152:
// rs2_val == 274877906944, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x400000000000;  op2val:0x4000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x400000000000, 0x4000000000, x1, 952, x2)

inst_153:
// rs2_val == 68719476736, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:0x1000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x11, 0x1000000000, x1, 960, x2)

inst_154:
// rs2_val == 34359738368, rs1_val == 1048576
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x800000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x100000, 0x800000000, x1, 968, x2)

inst_155:
// rs2_val == 8589934592, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x200000000000;  op2val:0x200000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x200000000000, 0x200000000, x1, 976, x2)

inst_156:
// rs2_val == 4294967296, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x100000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x100000, 0x100000000, x1, 984, x2)

inst_157:
// rs2_val == 2147483648, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffffd;  op2val:0x80000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffffd, 0x80000000, x1, 992, x2)

inst_158:
// rs2_val == 1073741824, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x40000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x5, 0x40000000, x1, 1000, x2)

inst_159:
// rs2_val == 536870912, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffff7ffffffff;  op2val:0x20000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffff7ffffffff, 0x20000000, x1, 1008, x2)

inst_160:
// rs2_val == 134217728, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x8000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x0, 0x8000000, x1, 1016, x2)

inst_161:
// rs2_val == 67108864, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000000000000000;  op2val:0x4000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000000000000000, 0x4000000, x1, 1024, x2)

inst_162:
// rs2_val == 33554432, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffdffffffffff;  op2val:0x2000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffdffffffffff, 0x2000000, x1, 1032, x2)

inst_163:
// rs2_val == 16777216, rs1_val == 65536
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x1000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x10000, 0x1000000, x1, 1040, x2)

inst_164:
// rs2_val == 8388608, rs1_val == 9223372036854775808
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000000000000;  op2val:0x800000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000000000000, 0x800000, x1, 1048, x2)

inst_165:
// rs2_val == 1048576, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x100000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x9, 0x100000, x1, 1056, x2)

inst_166:
// rs2_val == 524288, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffeffffffff;  op2val:0x80000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffeffffffff, 0x80000, x1, 1064, x2)

inst_167:
// rs2_val == 262144, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffdfffffffffff;  op2val:0x40000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffdfffffffffff, 0x40000, x1, 1072, x2)

inst_168:
// rs2_val == 65536, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffffffffdff;  op2val:0x10000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffffffffdff, 0x10000, x1, 1080, x2)

inst_169:
// rs2_val == 32768, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x8;  op2val:0x8000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x8, 0x8000, x1, 1088, x2)

inst_170:
// rs2_val == 16384, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xffffbfffffffffff;  op2val:0x4000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xffffbfffffffffff, 0x4000, x1, 1096, x2)

inst_171:
// rs2_val == 4096, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffbffffffff;  op2val:0x1000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0xfffffffbffffffff, 0x1000, x1, 1104, x2)

inst_172:
// rs2_val == 2048, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x800
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x2, 0x800, x1, 1112, x2)

inst_173:
// rs2_val == 1024, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:0x400
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x11, 0x400, x1, 1120, x2)

inst_174:
// rs2_val == 512, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x5555555555555556;  op2val:0x200
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x5555555555555556, 0x200, x1, 1128, x2)

inst_175:
// rs2_val == 256, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x20000000001;  op2val:0x100
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x20000000001, 0x100, x1, 1136, x2)

inst_176:
// rs2_val == 128, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:0x80
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x21, 0x80, x1, 1144, x2)

inst_177:
// rs2_val == 16, rs1_val == 268435456
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x10
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x10000000, 0x10, x1, 1152, x2)

inst_178:
// rs2_val == 8, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000000000000;  op2val:0x8
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000000000000, 0x8, x1, 1160, x2)

inst_179:
// rs2_val == 4, rs1_val == 68719476736
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1000000000;  op2val:0x4
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1000000000, 0x4, x1, 1168, x2)

inst_180:
// rs1_val == 288230376151711744, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x400000000000000;  op2val:0xffffffbfffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x400000000000000, 0xffffffbfffffffff, x1, 1176, x2)

inst_181:
// rs1_val == 36028797018963968, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x80000000000000;  op2val:0x80000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x80000000000000, 0x80000000, x1, 1184, x2)

inst_182:
// rs1_val == 4503599627370496, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x10000000000000;  op2val:-0x40000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x10000000000000, -0x40000001, x1, 1192, x2)

inst_183:
// rs1_val == 562949953421312, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2000000000000;  op2val:-0x80000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2000000000000, -0x80000000001, x1, 1200, x2)

inst_184:
// rs1_val == 140737488355328, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800000000000;  op2val:-0xa
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800000000000, -0xa, x1, 1208, x2)

inst_185:
// rs1_val == 17592186044416, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x100000000000;  op2val:0x5555555555555555
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x100000000000, 0x5555555555555555, x1, 1216, x2)

inst_186:
// rs1_val == 8796093022208, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x80000000000;  op2val:0xe
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x80000000000, 0xe, x1, 1224, x2)

inst_187:
// rs1_val == 2199023255552, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x20000000000;  op2val:0x4
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x20000000000, 0x4, x1, 1232, x2)

inst_188:
// rs1_val == 1099511627776, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x10000000000;  op2val:0xdfffffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x10000000000, 0xdfffffffffffffff, x1, 1240, x2)

inst_189:
// rs1_val == 549755813888, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000000;  op2val:-0x6
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000000, -0x6, x1, 1248, x2)

inst_190:
// rs1_val == 274877906944, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000000000;  op2val:-0xa
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000000000, -0xa, x1, 1256, x2)

inst_191:
// rs1_val == 137438953472, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2000000000;  op2val:0x0
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2000000000, 0x0, x1, 1264, x2)

inst_192:
// rs1_val == 17179869184, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x400000000;  op2val:0x400000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x400000000, 0x400000, x1, 1272, x2)

inst_193:
// rs1_val == 8589934592, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x200000000;  op2val:0x800
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x200000000, 0x800, x1, 1280, x2)

inst_194:
// rs1_val == 4294967296, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x100000000;  op2val:0x10
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x100000000, 0x10, x1, 1288, x2)

inst_195:
// rs1_val == 2147483648, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x80000000;  op2val:-0x11
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x80000000, -0x11, x1, 1296, x2)

inst_196:
// rs1_val == 536870912, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:0x80000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x20000000, 0x80000000000, x1, 1304, x2)

inst_197:
// rs1_val == 134217728, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0xfffffffffff7ffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000000, 0xfffffffffff7ffff, x1, 1312, x2)

inst_198:
// rs1_val == 67108864, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0xa
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000000, 0xa, x1, 1320, x2)

inst_199:
// rs1_val == 16777216, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:-0x100000000000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1000000, -0x100000000000001, x1, 1328, x2)

inst_200:
// rs1_val == 8388608, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0xfffbffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800000, 0xfffbffffffffffff, x1, 1336, x2)

inst_201:
// rs1_val == 4194304, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0x20
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x400000, 0x20, x1, 1344, x2)

inst_202:
// rs1_val == 2097152, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:-0x81
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x200000, -0x81, x1, 1352, x2)

inst_203:
// rs1_val == 524288, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:-0x2000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x80000, -0x2000001, x1, 1360, x2)

inst_204:
// rs1_val == 262144, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:-0x11
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x40000, -0x11, x1, 1368, x2)

inst_205:
// rs1_val == 32768, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:0xfffffffbffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x8000, 0xfffffffbffffffff, x1, 1376, x2)

inst_206:
// rs1_val == 8192, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:-0x801
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2000, -0x801, x1, 1384, x2)

inst_207:
// rs1_val == 4096, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x4000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x1000, 0x4000000, x1, 1392, x2)

inst_208:
// rs1_val == 2048, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0x5
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x800, 0x5, x1, 1400, x2)

inst_209:
// rs1_val == 1024, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:-0x400001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x400, -0x400001, x1, 1408, x2)

inst_210:
// rs1_val == 512, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:-0x1
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x200, -0x1, x1, 1416, x2)

inst_211:
// rs1_val == 256, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x100000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x100, 0x100000000, x1, 1424, x2)

inst_212:
// rs1_val == 64, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0xfffffffffffffeff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x40, 0xfffffffffffffeff, x1, 1432, x2)

inst_213:
// rs1_val == 32, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0x40000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x20, 0x40000000, x1, 1440, x2)

inst_214:
// rs1_val == 4, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x40000001
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4, -0x40000001, x1, 1448, x2)

inst_215:
// rs1_val == 2, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x10000000000000
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x2, 0x10000000000000, x1, 1456, x2)

inst_216:
// rs1_val == 0x75a3adb3254a9493 and rs2_val == 0xc5521660f3a3c571 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x75a3adb3254a9493;  op2val:0xc5521660f3a3c571
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x75a3adb3254a9493, 0xc5521660f3a3c571, x1, 1464, x2)

inst_217:
// rs2_val == 13835058055282163711, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0xbfffffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0x5, 0xbfffffffffffffff, x1, 1472, x2)

inst_218:
// rs2_val == 18446181123756130303, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0xfffdffffffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, 0x4000, 0xfffdffffffffffff, x1, 1480, x2)

inst_219:
// rs2_val == 18446744004990074879, 
// opcode: aes64ks2 ; op1:x10; op2:x11; dest:x12; op1val:-0xa;  op2val:0xffffffefffffffff
TEST_RR_OP(aes64ks2, x12, x10, x11, 0x0000000000000000, -0xa, 0xffffffefffffffff, x1, 1488, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 17*(XLEN/32),4,0xdeadbeef


signature_x9_0:
    .fill 16*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 187*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
